<?php
include 'Cloudinary.php';
include 'Uploader.php';
class Wpimage {

    protected $auth = array();

    public function __construct() {

        $custom_cloudinary_options = get_option('_wpimage_options_cloudinary');

        if( $custom_cloudinary_options && 1 === (int) $custom_cloudinary_options['enabled'] ){
            \Cloudinary::config( array(
                "cloud_name" => $custom_cloudinary_options['cloud_name'],
                "api_key" => $custom_cloudinary_options['api_key'],
                "api_secret" => $custom_cloudinary_options['api_secret'] )
            );
        }
        else{
            \Cloudinary::config(
                array(
                    "cloud_name" => 'cdn-hosting-io',
                    "api_key" => '211466787232616',
                    "api_secret" => 'MR1qKhLKwOMKIlYKte_CR-kxgKo'
                )
            );
        }
    }

    public function upload( $opts = array() ) {

        global $wpdb;

        $custom_cloudinary_options = get_option('_wpimage_options_cloudinary');

        if( ! $custom_cloudinary_options || 1 !== (int) $custom_cloudinary_options['enabled'] ){

            $exist = $wpdb->get_row("SELECT * FROM " . $wpdb->prefix . "image_compression_settings", ARRAY_A);

            if( $exist && 0 >= $exist['total_allowed'] ) {
                return false;
            }
        }

        if ( ! isset($opts['file']) ) {
            return array(
                "success" => false,
                "error" => "File parameter was not provided"
            );
        }

        if ( ! file_exists($opts['file']) ) {
            return array(
                "success" => false,
                "error" => "File `" . $opts['file'] . "` does not exist"
            );
        }

        if ( function_exists('curl_file_create') ) {
            $file = sprintf( '%s', $opts['file'] );
            //$file = curl_file_create($opts['file'], 'image/jpeg', $opts['file']);
        }
        else {
            $file = sprintf( '%s', $opts['file'] );
        }

        unset($opts['file']);

        // $file = str_replace($_SERVER['DOCUMENT_ROOT'],'http://'.$_SERVER['HTTP_HOST'],$file);
        if ($opts['backup_before_compression']) {
            //backup the image first
            $upload_dir = wp_upload_dir();
            $user_dirname = $upload_dir['basedir'].'/optimisationio_media_backup';
            if ( ! file_exists( $user_dirname ) ) {
                wp_mkdir_p( $user_dirname );
            }
            copy($file, $user_dirname.'/'.basename($file));
        }
	    $img = filesize($file);
        $options = array();
        $source = wpimages_get_source();

        list($maxW, $maxH) = wpimages_get_max_width_height($source);
        if ($maxW > 0) {
            $options['width'] = $maxW;
        }
        if ($maxH > 0) {
            $options['height'] = $maxH;
        }
        if ($opts['wpimages_quality']) {
            $options['quality'] = $opts['wpimages_quality'];
        }

        $options['crop'] = 'limit';
        try{
            $response = \Cloudinary\Uploader::upload($file, $options);
        }catch(Exception $e){
            //no compression
            return false;
        }

        if ($response) {

            $bytes = $this->getsize($response['url']);

            $custom_cloudinary_options = get_option('_wpimage_options_cloudinary');

            if( ! $custom_cloudinary_options || 1 !== (int) $custom_cloudinary_options['enabled'] ){

                if (!$exist) {
                    $array = array();
                    $array['total_size_optimized'] = $bytes/1000;
                    $array['total_image_optimized'] = 1;
                    $array['total_allowed'] = 500-1;
                    $array['created'] = date('Y-m-d H:i:s');
                    $wpdb->insert($wpdb->prefix."image_compression_settings", $array);
                }
                else {
                    $array = array();
                    $array['total_size_optimized'] = $exist['total_size_optimized'] + $bytes/1000;
                    $array['total_image_optimized'] = max(0, $exist['total_image_optimized']+1);
                    $array['total_allowed'] = $exist['total_allowed']-1;
                    $array['modified'] = date('Y-m-d H:i:s');
                    $wpdb->update($wpdb->prefix."image_compression_settings", $array, array('id'=>$exist['id']));
                }
            }

            $response['original_size'] = $img;
            $response['bytes'] = $bytes;
            $response['compressed_size'] = $bytes;
            $response['saved_bytes'] = $response['original_size'] - $bytes;
            $response['backup_before_compression'] = $opts['backup_before_compression'];
        }

        return $response;
    }

    public function getsize( $url ) {
        $curl = curl_init();
        curl_setopt_array( $curl, array(
            CURLOPT_URL => $url,
            CURLOPT_HEADER => true,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_NOBODY => true
        ));
        $headers = explode( "\n", curl_exec( $curl ) );
        curl_close( $curl );
        foreach ($headers as $key => $header) {
            if (strpos($header, "Length") > 0) {
                return  (int) str_replace( 'Content-Length: ', '', $header ) ;
            }
        }
        return isset( $headers[4] ) ? (int) str_replace( 'Content-Length: ', '', $headers[4] ) : 0;
    }

    public function deleteResource( $public_id ) {
        \Cloudinary\Uploader::destroy( $public_id );
    }

    private function request( $data, $url ) {
        $curl = curl_init( $url );
        curl_setopt( $curl, CURLOPT_URL, $url );
        curl_setopt( $curl, CURLOPT_POST, 1 );
        curl_setopt( $curl, CURLOPT_RETURNTRANSFER, 1 );
        curl_setopt( $curl, CURLOPT_POSTFIELDS, $data );
        curl_setopt( $curl, CURLOPT_CONNECTTIMEOUT, 0 );
        curl_setopt( $curl, CURLOPT_TIMEOUT, 400 );
        curl_setopt( $curl, CURLOPT_SSL_VERIFYPEER, 0 );
        curl_setopt( $curl, CURLOPT_SSL_VERIFYHOST, 0 );
        curl_setopt( $curl, CURLOPT_FAILONERROR, 0 );
        $response = json_decode( curl_exec( $curl ), true );
        $error = curl_errno( $curl );
        curl_close( $curl );
        if( 0 < $error ) {
            throw new RuntimeException( sprintf( 'cURL returned with the following error code: "%s"', $error ) );
        }
        return $response;
    }
}
