<?php
global $wpdb;

$default_options_cloudinary = array(
    'enabled' => 0,
    'invalid_msg' => '',
    'cloud_name' => '',
    'api_key' => '',
    'api_secret' => ''
);

// Getting the optimisation stats from db.
$img_compress_sett = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."image_compression_settings", ARRAY_A);

$wpimage_options = unserialize(get_option('_wpimage_options'));
$wpimage_options['backup_before_compression'] = isset( $wpimage_options['backup_before_compression'] ) ? $wpimage_options['backup_before_compression'] : false;

$cloudinary_options = get_option('_wpimage_options_cloudinary', $default_options_cloudinary );

$valid_cloudinary_creds_msg = '';
$invalid_cloudinary_creds_msg = '';

if( isset( $cloudinary_options['invalid_msg'] ) && '' !== $cloudinary_options['invalid_msg']  ){
    $invalid_cloudinary_creds_msg = $cloudinary_options['invalid_msg'];
}
else if( isset( $cloudinary_options['success_msg'] ) && '' !== $cloudinary_options['success_msg']  ){
    $valid_cloudinary_creds_msg = $cloudinary_options['success_msg'];
}

?>
<div class="sidebar-cloudinary-api">

    <div class="sidebar-title-wrap">
        <span><?php esc_html_e('API Settings', 'optimisationio'); ?></span>
    </div>

    <form action="<?php echo esc_url( admin_url( 'admin.php?page=optimisationio-dashboard' ) ); ?>" method="post">
        
        <div class="sidebar-content-wrap">

            <?php if( '' !== $invalid_cloudinary_creds_msg || '' !== $valid_cloudinary_creds_msg ){ ?>
                <div class="addon-settings-content auto-table-layout">

                    <?php if( '' !== $invalid_cloudinary_creds_msg ){ ?>
                        <div class="field" style="padding:5px 5px 0;">
                            <div class="field-left" style="padding:0.75rem; color:#fff; background-color:#dc3232;">
                                <?php echo $invalid_cloudinary_creds_msg; ?>
                                <span class="close-cloudinary-api-msg">x</span>
                            </div>
                        </div>
                    <?php } ?>

                    <?php if( '' !== $valid_cloudinary_creds_msg ){ ?>
                        <div class="field" style="padding:5px 5px 0;">
                            <div class="field-left" style="padding:0.75rem 1.5rem 0.75rem 0.75rem; color:#fff; background-color:#a6ca8a;">
                                <?php echo $valid_cloudinary_creds_msg; ?>
                                <span class="close-cloudinary-api-msg">x</span>
                            </div>
                        </div>
                    <?php } ?>

                </div>
            <?php } ?>

            <div class="addon-settings-content auto-table-layout">
                <div class="field">
                    <div class="field-left"><?php esc_html_e('Optimise images using own Cloudinary account', 'optimisationio'); ?></div>
                    <div class="field-right">
                    <?php Optimisationio_Dashboard::checkbox_component( 'custom_cloudinary[enabled]', 1 === (int) $cloudinary_options['enabled'] ); ?>
                    </div>
                </div>
            </div>

            <div class="addon-settings-content custom-cloudinary-group">
                <div class="field brd-top">
                    <div class="field-left"><?php esc_html_e('Cloud name', 'optimisationio'); ?></div>
                    <div class="field-right"><input type="text" name="custom_cloudinary[cloud_name]" value="<?php if ( isset( $cloudinary_options['cloud_name'] ) ) { echo esc_attr( $cloudinary_options['cloud_name'] ); } ?>" /></div>
                </div>
                <div class="field">
                    <div class="field-left"><?php esc_html_e('Api Key', 'optimisationio'); ?></div>
                    <div class="field-right"><input type="text" name="custom_cloudinary[api_key]" value="<?php if ( isset( $cloudinary_options['api_key'] ) ) { echo esc_attr( $cloudinary_options['api_key'] ); } ?>" /></div>
                </div>
                <div class="field">
                    <div class="field-left"><?php esc_html_e('Api Secret', 'optimisationio'); ?></div>
                    <div class="field-right"><input type="text" name="custom_cloudinary[api_secret]" value="<?php if ( isset( $cloudinary_options['api_secret'] ) ) { echo esc_attr( $cloudinary_options['api_secret'] ); } ?>" /></div>
                </div>
            </div>
            <div class="addon-settings-content auto-table-layout">
                <div class="field brd-top">
                    <div class="field-left"><?php esc_html_e('Backup image before compression', 'optimisationio'); ?></div>
                    <div class="field-right">
                    <?php Optimisationio_Dashboard::checkbox_component( '_wpimage_options[backup_before_compression]', 1 === (int) $wpimage_options['backup_before_compression'] ); ?>
                    </div>
                </div>
            </div>
        </div>

        <div class="addon-settings-actions-section">
            <input type="submit" class="button button-primary button-large" name="optimisation_save_cloudinary_api_settings" value="<?php echo esc_attr("Save", "optimisationio"); ?>" />
        </div>

        <?php wp_nonce_field( 'optimisationio-cloudinary-api-settings', 'optimisationio_cloudinary_api_settings' ); ?>
    </form>
</div>

<div class="sidebar-cloudinary-api auto-cloudinary-group">
        <div class="sidebar-content-wrap">
            <div class="addon-settings-content auto-table-layout">
                <div class="field">
                    <div class="field-left"><strong><?php esc_html_e('Bulk optimise all images', 'optimisationio'); ?></strong></div>
                    <div class="field-right">
                        <button id="bulk_optimisation_button" class="not-while-exe button button-primary button-large"><?php echo esc_attr("GO", "optimisationio"); ?></button>
                        <span class="optimising-images-icon"></span>
                    </div>
                </div>
            </div>
        </div>
    </div>

<?php if( $include_upgrade ){ ?>
    <div class="sidebar-cloudinary-api auto-cloudinary-group">
        <div class="free-api-stats">
            <div><?php esc_html_e('Total allowed images optimisation', 'optimisationio'); ?>: <span><?php echo ($img_compress_sett['total_allowed']) ? $img_compress_sett['total_allowed'] : 1000; ?></span></div>
        </div>
        <div class="sidebar-content-wrap">
            <div class="addon-settings-content auto-table-layout">
                <div class="field">
                    <div class="field-left"><?php esc_html_e('Image Quantity', 'optimisationio'); ?></div>
                    <div class="field-right">
                        <select id="stripepackage">
                            <option value="1000">&pound;10 for 1,000 image optimisation</option>
                            <option value="4000">&pound;40 for 5,000 image optimisation</option>
                            <option value="8000">&pound;80 for 10,000 image optimisation</option>
                            <option value="15000">&pound;150 for 20,000 image optimisation</option>
                        </select>
                    </div>
                </div>
            </div>
            <div class="addon-settings-actions-section">
                <input id="stripe_button" type="submit" class="button button-primary button-large" value="<?php echo esc_attr("UPGRADE", "optimisationio"); ?>" />
            </div>
        </div>
    </div> <?php
}

if( '' !== $valid_cloudinary_creds_msg || '' !== $invalid_cloudinary_creds_msg ){
    $updated_options_cloudinary = $cloudinary_options;
    $updated_options_cloudinary['invalid_msg'] = '';
    $updated_options_cloudinary['success_msg'] = '';
    update_option( '_wpimage_options_cloudinary', $updated_options_cloudinary );
    unset( $updated_options_cloudinary );
}	